rem mode CON:COLS=90 LINES=800
mode CON:COLS=78 LINES=32
@echo off
cls
rem ------ Edit  ------ START -------
set platform=x32
set core-input=ng-core-x32-url.txt
set plugins-input=ng-plugins-x32-url.txt
set langpack-input=ng-language-pack-x32-url.txt
rem ------ Edit  ------ END -------


set ng-dlpack=.\Downloads-Miranda-NG-%platform%
rem set ng-prg=.\Miranda_NG_%platform%
set ng-prg=.\


set curr-dir=%~dp0
set curr-dir=%curr-dir:~0,-1%
set dl-fail=errors-download.txt

set wget=..\..\_Scripte\_Hilfs-Programme\wget\wget.exe
set zip-pack=..\..\_Scripte\7-Zip\cmd-packer\7z-cmd-packer.exe
if exist ".\Tools\wget.exe" set wget=".\Tools\wget.exe"
%zip-pack% -y

set PCKPATH=%temp%\7z-cmd-packer
set cmd-7z="%temp%\7z-cmd-packer\7za.exe"

if exist ".\Tools\7za.exe" set PCKPATH=.\Tools
if exist "%PCKPATH%\7za.exe" set cmd-7z="%PCKPATH%\7za.exe"
if not exist %cmd-7z% goto fail-7z
if exist %PCKPATH%\7za.exe goto start

:fail-7z
cls
echo.
echo File
echo %cmd-7z%
echo does not exist.
echo aborting.
echo.
pause
goto end

:err-core
set errchoice=
cls
echo.
echo   %dl-core%
echo   Download fehlgeschlagen.
echo.
echo     URL in der Quell-Datei "%core-input%" veraltet.
echo.
echo  Download Homepage ffnen = Beliebige Taste drcken.
pause > nul
start http://wiki.miranda-ng.org/index.php?title=Downloads
goto end

:cleanup
rmdir /s /q "%ng-dlpack%"
rmdir /s /q "%ng-prg%"
del %dl-fail%
for /f "eol=; skip=1 tokens=1 delims=," %%a in (%core-input%) do @(for /f "tokens=*" %%b in ("%%a") do del %%~na%%~xa)
for /f "eol=; skip=1 tokens=1 delims=," %%a in (%plugins-input%) do @(for /f "tokens=*" %%b in ("%%a") do del %%~na%%~xa)
for /f "eol=; skip=1 tokens=1 delims=," %%a in (%langlangpack-input%) do @(for /f "tokens=*" %%b in ("%%a") do del %%~na%%~xa)
set dl-oldfiles=
goto start


:start
if exist *.zip set dl-oldfiles=1
if exist *.7z set dl-oldfiles=1

if defined dl-oldfiles goto cleanup

md "%ng-dlpack%"
md "%ng-prg%"

rem ---- Download Core Pack  ----- Start ---
for /f "eol=; skip=1 tokens=1 delims=," %%a in (%core-input%) do %wget% %%a
rem -- extract a filename from a url / check file exist / report if file not exist ---- 
echo --- Core and basic plugins  ---  > %dl-fail%
for /f "eol=; skip=1 tokens=1 delims=," %%a in (%core-input%) do @(for /f "tokens=*" %%b in ("%%a") do if not exist %%~na%%~xa echo %%~na%%~xa - file could not be downloaded >> %dl-fail%)
rem -- exist check for core
for /f "eol=; skip=1 tokens=1 delims=," %%a in (%core-input%) do @(for /f "tokens=*" %%b in ("%%a") do set dl-core=%%~na%%~xa)
for /f "eol=; skip=1 tokens=1 delims=," %%a in (%core-input%) do @(for /f "tokens=*" %%b in ("%%a") do if not exist %%~na%%~xa goto err-core)
move %dl-core% "%ng-dlpack%"
rem ---- Download Core Pack  ----- End ---

rem ---- Download Plugins  ----- Start ---
for /f "eol=; skip=1 tokens=1 delims=," %%a in (%plugins-input%) do %wget% %%a
rem -- extract a filename from a url / check file exist / report if file not exist ---- 
echo --- Plugins  ---  >> %dl-fail%
for /f "eol=; skip=1 tokens=1 delims=," %%a in (%plugins-input%) do @(for /f "tokens=*" %%b in ("%%a") do if not exist %%~na%%~xa echo %%~na%%~xa - file could not be downloaded >> %dl-fail%)
for /f "eol=; skip=1 tokens=1 delims=," %%a in (%plugins-input%) do @(for /f "tokens=*" %%b in ("%%a") do move %%~na%%~xa "%ng-dlpack%")
rem for /f "eol=; skip=1 tokens=1 delims=," %%a in (%plugins-input%) do move %%a %ng-prg%
rem ---- Download Plugins  ----- End ---

rem ---- Download Language Packs ----- Start ---
for /f "eol=; skip=1 tokens=1 delims=," %%a in (%langpack-input%) do %wget% %%a
echo --- Language Packs ---  >> %dl-fail%
rem -- extract a filename from a url / check file exist / report if file not exist ---- 
for /f "eol=; skip=1 tokens=1 delims=," %%a in (%langpack-input%) do @(for /f "tokens=*" %%b in ("%%a") do if not exist %%~na%%~xa echo %%~na%%~xa - file could not be downloaded >> %dl-fail%)
for /f "eol=; skip=1 tokens=1 delims=," %%a in (%langpack-input%) do @(for /f "tokens=*" %%b in ("%%a") do move %%~na%%~xa "%ng-dlpack%")
rem ---- Download Language Packs ----- End ---


rem ---- Unpack Core ----- Start ---
%cmd-7z% x "%ng-dlpack%\%dl-core%" -o"%ng-prg%" -aoa
rem ---- Unpack Core  ----- End ---

rem ---- Unpack Plugins ----- Start ---
for /f "eol=; skip=1 tokens=1 delims=," %%a in (%plugins-input%) do @(for /f "tokens=*" %%b in ("%%a") do %cmd-7z% x "%ng-dlpack%\%%~na%%~xa" -o"%ng-prg%" -aoa)
rem ---- Unpack Plugins ----- End ---

rem ---- Unpack Language Packs ----- Start ---
for /f "eol=; skip=1 tokens=1 delims=," %%a in (%langpack-input%) do @(for /f "tokens=*" %%b in ("%%a") do %cmd-7z% x "%ng-dlpack%\%%~na%%~xa" -o"%ng-prg%\Languages" -aoa)
rem ---- Unpack Language Packs ----- End ---

move "%ng-prg%\*.7z" "%ng-dlpack%"
move "%ng-prg%\*.zip" "%ng-dlpack%"

rmdir "%ng-dlpack%" /s /q
rmdir ".\Tools\" /s /q
del %core-input%
del %plugins-input%
del %langpack-input%
del %0




:end